# -*- mode: makefile; -*-
# Do not edit, this is file generated by m4 from Makefile.4sim.m4 and 
#  copied to the simulations while installation! 
# Make your changes in Makefile.conf.
#  E.g. add there files to compile or custom libs and so on.

# File:       Makefile for lpzrobots simulations
# Author:     Georg Martius  <georg.martius at web.de>
# Date:       Oct 2009

define(`COMMENT', )
COMMENT(`There are defines for platform dependend stuff.
         DEV only produces output in the development version
         DEVORUSER  choice between development (first argument) or user (second)
         LINUXORMAC outputs the first argument on linux and the second on mac.')

ifdef(`DEVEL',
`define(`DEVORUSER', $1) define(`DEV', $1)'
,
`define(`DEVORUSER', $2) define(`DEV',)'
)
ifdef(`MAC', 
`define(`LINUXORMAC', $2)'
,
`define(`LINUXORMAC', $1)'
)

EXEC = start
# add files to compile in the conf file
include Makefile.conf

CFILES = $(addsuffix .cpp, $(FILES))
OFILES = $(addsuffix .o, $(FILES))

# the CFGOPTS are set by the opt and dbg target
CFGOPTS=
INC    += -I.
BASELIBS = $(shell ga_tools-config $(CFGOPTS) --static --libs) $(shell ode_robots-config $(CFGOPTS) --static --libs) $(shell selforg-config $(CFGOPTS) --static --libs) 
BASELIBSSHARED := $(shell ga_tools-config $(CFGOPTS) --libs) $(shell ode_robots-config $(CFGOPTS) --libs) $(shell selforg-config $(CFGOPTS) --libs)

DEV(LIBSELFORG=$(shell selforg-config $(CFGOPTS) --libfile))
DEV(SELFORGSRCPREFIX=$(shell selforg-config $(CFGOPTS) --srcprefix))

DEV(LIBODEROBOTS=$(shell ode_robots-config $(CFGOPTS) --libfile))
DEV(ODEROBOTSSRCPREFIX=$(shell ode_robots-config $(CFGOPTS) --srcprefix))

DEV(LIBGATOOLS=$(shell ga_tools-config $(CFGOPTS) --libfile))
DEV(GATOOLSSRCPREFIX=$(shell ga_tools-config $(CFGOPTS) --srcprefix))

LIBS  += $(BASELIBS) $(ADDITIONAL_LIBS)

INC   += -I.

CXX = g++
CPPFLAGS = -Wall -pipe -Wno-deprecated $(INC) $(shell selforg-config $(CFGOPTS) --cflags) \
  $(shell ode_robots-config $(CFGOPTS) --intern --cflags) 

normal: DEV(libode_robots libga_tools) 
	$(MAKE) $(EXEC)
opt:    DEV(libode_robots_opt libga_tools_opt) 
	$(MAKE) CFGOPTS=--opt EXEC=$(EXEC)_opt $(EXEC)_opt
dbg:    DEV(libode_robots_dbg libga_tools_dbg) 
	$(MAKE) CFGOPTS=--dbg EXEC=$(EXEC)_dbg $(EXEC)_dbg
shared:  DEV(libode_robots_shared libga_tools_shared) 
	$(MAKE) BASELIBS="$(BASELIBSSHARED)" EXEC=$(EXEC)_shared $(EXEC)_shared

$(EXEC): Makefile Makefile.depend $(OFILES) DEV($(LIBSELFORG) $(LIBODEROBOTS) $(LIBGATOOLS))
	$(CXX) $(CPPFLAGS) $(OFILES) $(LIBS) -o $(EXEC)

DEV(
libode_robots:	
	cd $(ODEROBOTSSRCPREFIX) && $(MAKE) lib

libode_robots_dbg:	
	cd $(ODEROBOTSSRCPREFIX) && $(MAKE) dbg

libode_robots_opt:	
	cd $(ODEROBOTSSRCPREFIX) && $(MAKE) opt

libode_robots_shared:	
	cd $(ODEROBOTSSRCPREFIX) && $(MAKE) shared

libga_tools:	
	cd $(GATOOLSSRCPREFIX) && $(MAKE) lib

libga_tools_dbg:	
	cd $(GATOOLSSRCPREFIX) && $(MAKE) dbg

libga_tools_opt:	
	cd $(GATOOLSSRCPREFIX) && $(MAKE) opt

libga_tools_shared:	
	cd $(GATOOLSSRCPREFIX) && $(MAKE) shared
)

Makefile.depend: 
	makedepend -- $(CPPFLAGS) -- $(CFILES) -f- > Makefile.depend 2>/dev/null

depend: 
	makedepend -- $(CPPFLAGS) -- $(CFILES)  -f- > Makefile.depend 2>/dev/null

tags: 
	etags $(find -name "*.[ch]")

DEV(
cleandist: clean-all
clean-all: clean
	cd $(GATOOLSSRCPREFIX) && make clean-all
	cd $(ODEROBOTSSRCPREFIX) && make clean-all
	cd $(SELFORGSRCPREFIX) && make clean-all
)

clean:
	rm -f $(EXEC) $(EXEC)_dbg $(EXEC)_opt *.o Makefile.depend

-include Makefile.depend
